#include <SPI.h>
#include <UIPEthernet.h>

#define Kpw 3200    //коэффициент пересчета импульсов счетчика
#define KPtim 3600000000/Kpw    //коэфф.для подсчета мощности по 
                  //длит.периода импульсов (длительности мерим в мс)
                  
unsigned long time;
unsigned long timeM;
unsigned long timeOld;
unsigned long PerImp;
const int pinPw = 8;  //вывод для подключения оптрона счетчика эл.эн.
byte pinPwOld = 1;    //старое значение состояния входа
long datD;
byte i;

// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = {
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED
};
IPAddress ip(192, 168, 0, 96);

// Initialize the Ethernet server library
// with the IP address and port you want to use
// (port 80 is default for HTTP):
EthernetServer server(80);


//Установка Таймера2.
//Конфигурирует 8-битный Таймер2 ATMega168 для выработки прерывания
//с периодом около 16 мс.
void SetupTimer2()  {
//Установки Таймер2: Делитель частоты /1024, режим 0
//Частота = 16MHz/1024 =  16.384 мс
TCCR2A = 0; 
TCCR2B = 1<<CS22 | 1<<CS21 | 1<<CS20;   //на 1024
//Подключение прерывания по переполнению Timer2
TIMSK2 = 1<<TOIE2;
}

//Timer2 указатель вектора прерывания по переполнению
ISR(TIMER2_OVF_vect)  {
//приращение переменной
time ++;
int valpinPw = digitalRead(pinPw);
if (valpinPw == 0) {pinPwOld = 0;}
else {
  if (pinPwOld == 0)
  { pinPwOld = 1;
    timeM = millis();
    PerImp = timeM - timeOld;
    timeOld = timeM;
  }  
}
}


void setup() {
  // Open serial communications and wait for port to open:
  Serial.begin(9600);

  // start the Ethernet connection and the server:
  Ethernet.begin(mac, ip);
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());
  
    //для подсчета мощности
  time = 0;
  timeOld = millis();
  PerImp = 1;
  pinMode(pinPw, INPUT);
  digitalWrite(pinPw, 1); // вкл внутр резистор
  Serial.begin(9600);
  SetupTimer2();  //прерывания таймера - подчет мощности
  
}


void loop() {
   datD = KPtim/PerImp;  //текущая потребляемая мощность
  
  // listen for incoming clients
  EthernetClient client = server.available();
  if (client) {
    Serial.println("new client");
    // an http request ends with a blank line
    boolean currentLineIsBlank = true;
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
        Serial.write(c);
        // if you've gotten to the end of the line (received a newline
        // character) and the line is blank, the http request has ended,
        // so you can send a reply
        if (c == '\n' && currentLineIsBlank) {
          // send a standard http response header
          client.println("HTTP/1.1 200 OK");
          client.println("Content-Type: text/html");
          client.println("Connection: close");  // the connection will be closed after completion of the response
          client.println("Refresh: 5");  // refresh the page automatically every 5 sec
          client.println();
          client.println("<!DOCTYPE HTML>");
          client.println("<html>");
          client.println("<meta http-equiv='content-type' content='text/html; charset=UTF-8'>");
          client.println("<title>ВАТТМЕТР</title>");

client.print(datD);
client.print(" Ватт");

          client.println("</html>");
          break;
        }
        if (c == '\n') {
          // you're starting a new line
          currentLineIsBlank = true;
        }
        else if (c != '\r') {
          // you've gotten a character on the current line
          currentLineIsBlank = false;
        }
      }
    }
    // give the web browser time to receive the data
    delay(1);
    // close the connection:
    client.stop();
    Serial.println("client disconnected");
  }
}

